﻿using anbs_cp.Classes;

namespace anbs_cp.Interfaces;

/// <summary>
/// Интерфейс класса, хранящего в себе состояния действия
/// </summary>
public interface IActionState
{
    /// <summary>
    /// Список информации
    /// </summary>
    List<IActionInfo> Info { get; }

    /// <summary>
    /// Список предупреждений
    /// </summary>
    List<IActionWarning> Warnings { get; }

    /// <summary>
    /// Список ошибок
    /// </summary>
    List<IActionError> Errors { get; }

    /// <summary>
    /// Добавляет другое состояние (например, результат другого действия, который возвращает <see cref="ActionState{T}"/>).
    /// </summary>
    /// <typeparam name="T">Тип параметра</typeparam>
    /// <param name="state">Запись состояния</param>
    void AddState (IActionState state);
}